--[[
Author: Starinnia
CPR is a combo points display addon based on Funkydude's BasicComboPoints
Arcane.lua - A module for tracking Arcane Blast debuff stacks
$Date: 2010-10-16 21:30:00 +0000 (Sat, 16 Oct 2010) $
$Revision: 168 $
Project Version: r171
contact: codemaster2010 AT gmail DOT com

Copyright (c) 2007-2010 Michael J. Murray aka Lyte of Lothar(US)
All rights reserved unless otherwise explicitly stated.
]]

if select(2, UnitClass("player")) ~= "MAGE" then return end

local cpr = LibStub("AceAddon-3.0"):GetAddon("ComboPointsRedux")
local modName = "Arcane Blast"
local ArcaneModule = cpr:NewModule(modName, "AceConsole-3.0", "AceEvent-3.0")
local buff = GetSpellInfo(36032)

function ArcaneModule:OnInitialize()
	self.abbrev = "AB"
	self.MAX_POINTS = 4
	self.displayName = buff
end

function ArcaneModule:OnEnable()
	if not cpr.db.profile.modules[modName].disableGraphics then
		if not self.graphics then
			self.graphics = cpr:MakeGraphicsFrame(modName, self.MAX_POINTS)
		end
		self.graphics:Show()
	end
	if not cpr.db.profile.modules[modName].disableText then
		if not self.text then
			self.text = cpr:MakeTextFrame(modName)
		end
		self.text:Show()
	end
	
	self:RegisterEvent("UNIT_AURA")
end

function ArcaneModule:OnDisable()
	if self.graphics then self.graphics:Hide() end
	if self.text then self.text:Hide() end
	self:UnregisterAllEvents()
end

function ArcaneModule:UNIT_AURA(_, unit)
	if unit ~= "player" then return end
	
	local _, _, _, count = UnitDebuff("player", buff)
	if count then
		local r, g, b = cpr:GetColorByPoints(modName, count)
		for i = count, 1, -1 do
			self.graphics.points[i].icon:SetVertexColor(r, g, b)
			self.graphics.points[i]:Show()
		end
		for j = self.MAX_POINTS, count+1, -1 do
			self.graphics.points[j]:Hide()
		end
		if self.text then self.text:SetNumPoints(count) end
	else
		for i = 1, self.MAX_POINTS do
			self.graphics.points[i]:Hide()
		end
		if self.text then self.text:SetNumPoints("") end
	end
end
